/* NsmConText: Nvu Site Manager ConText extension
 *
 * This patch of the site manager opens non-html files with external editors.
 * It also integrates a Launchy menu (http://gemal.dk/mozilla/launchy.html) into N|vu's site manager.
 *
 * My main goals are:
 *    > preview html files in Firefox, IE, Opera, ...
 *    > edit code files (js, php, asp...) with an appropriate editor
 *    > html-tidy files ("pretty-print" the code)
 *    > share launchy.xml with Firefox
 * 
 * For now, there are only 3 fixed file categories:
 *    > images files (as defined in the 'IsHiddenByFilter' function)
 *    > css stylesheets (to open with cascades, not working yet)
 *    > non-html, non-image files (to open with a text editor)
 * An option box allows to choose a editor for each category.
 *
 * TODO (= planned for sometime):
 *    > modify the option box to let the user add categories (id + name + regexp + command line)
 *    > auto reload html documents after editing html or css files with external apps
 *    > open CSS files with CaScadeS
 *    > "FTP sync" menu entry (I really miss that feature!)
 *    > XUL interface for ImageMagick (wouldn't that be neat?!?)
 *
 * Known bugs (= should be corrected soon):
 *    > Launchy integration is limited (you can't pass args, MIME type is ignored, ...)
 *    > ugly code (no 'locales' yet for instance...)
 *    > this is my first XUL hack... there might be lots of bugs :-(
 */

//
// Nsm windows & prefs
var NsmPrefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService).getBranch("editor.nvu.sitemanager.");
var NsmBundle = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService).getBranch("editor.nvu.sitemanager.nsmbundle.");
var NsmPublishPrefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService).getBranch("editor.publish.site_data.");
var ToolbarPrefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefService).getBranch("editor.toolbars.");

var NsmApps;

function openPropDialog() {
	//~ var args = new Array();
	//~ args[0] = "test";
	//~ args[1] = "gInitialSiteName";
	//~ args[2] = "gReturnData";
  //~ openDialog("chrome://editor/content/EditorPublish.xul","Publish","dialog=yes", args);
  //~ openDialog("chrome://editor/content/EditorPublish.xul","Publish","dialog=yes", "", "gInitialSiteName", "gReturnData");
        var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	//~ var publishData = CreatePublishDataFromUrl(docUrl);
	//~ window.openDialog("chrome://editor/content/EditorPublish.xul","_blank", 
                        //~ "chrome,close,titlebar,modal", docUrl, "Leo", publishData);
	var siteItem = GetSelectedSite();
	var username = {value:""};
	var size = item.size + " bytes";
	if (item.size >= 1024*1024)
		size = Math.round(10 * item.size / (1024*1024)) /10 + " MB (" + size + ")";
	else if (item.size >= 1024)
		size = Math.round(10 * item.size / 1024) /10 + " KB (" + size + ")";
	//~ var type = GetItemType(item);
	alert (item.url.replace(siteItem.url, "")
		+ "\n" + (item.isContainer ? "Folder" : GetItemType(item) + ", " + size)
		+ "\nlast modified: " + item.lastModified
		+ "\n\nSite : " + siteItem.name
		+ "\n" + siteItem.browseUrl
		+ "\n" + StripUsernamePassword(siteItem.url, username).replace("%2E", "."),
		"Properties", "Properties", "Properties");
}

function openCascadesDialog() {
  // this function doesn't work yet (never called anyway)
  //~ var doc = new ??? 
  //~ alert("CaScadeS");
  window.openDialog("chrome://cascades/content/EdCssProps.xul","_blank", "chrome,close,modal,titlebar");
  window._content.focus();
  //~ alert("Done");
}

function openPrefDialog() {
  openDialog("chrome://nsmcontext/content/NsmConText.xul","Preferences","dialog=yes");
}
function openLaunchyDialog() {
  openDialog("chrome://launchy/content/options.xul","Launchy","dialog=yes");
}
function openLaunchyXml() {
	var AppPath = NsmPrefs.getCharPref("extEditor");
	NsmLaunchExe(AppPath, LaunchyContext.xmlfile);
}
function getNsmPrefs() {
	document.getElementById("NsmDefaultEditor-img").value = NsmPrefs.getCharPref("imgEditor");
	document.getElementById("NsmDefaultEditor-css").value = NsmPrefs.getCharPref("cssEditor");
	document.getElementById("NsmDefaultEditor-ext").value = NsmPrefs.getCharPref("extEditor");
	
	document.getElementById("NsmHtmlShowBrowsers").checked = NsmPrefs.getBoolPref("ShowBrowsers");
	document.getElementById("NsmHtmlShowEditors").checked  = NsmPrefs.getBoolPref("ShowEditors");
	
	document.getElementById("StructToolbar-ShowId").checked    = ToolbarPrefs.getBoolPref("ShowId");
	document.getElementById("StructToolbar-ShowClass").checked = ToolbarPrefs.getBoolPref("ShowClass");
	document.getElementById("StructToolbar-ShowAttrs").checked = ToolbarPrefs.getBoolPref("ShowAttrs");
}

function setNsmPrefs() {
	NsmPrefs.setCharPref("imgEditor", document.getElementById("NsmDefaultEditor-img").value);
	NsmPrefs.setCharPref("cssEditor", document.getElementById("NsmDefaultEditor-css").value);
	NsmPrefs.setCharPref("extEditor", document.getElementById("NsmDefaultEditor-ext").value);
	launchyContext.doInit();
	
	NsmPrefs.setBoolPref("ShowBrowsers", document.getElementById("NsmHtmlShowBrowsers").checked);
	NsmPrefs.setBoolPref("ShowEditors",  document.getElementById("NsmHtmlShowEditors").checked);
	
	ToolbarPrefs.setBoolPref("ShowId",    document.getElementById("StructToolbar-ShowId").checked);
	ToolbarPrefs.setBoolPref("ShowClass", document.getElementById("StructToolbar-ShowClass").checked);
	ToolbarPrefs.setBoolPref("ShowAttrs", document.getElementById("StructToolbar-ShowAttrs").checked);
	UpdateStructToolbar;
}

function NsmEdit(newTab, FileURL) {
	//~ var prefs = window.top.GetPrefs();
	//~ var newTab = false; // default is false
	//~ try {
		//~ newTab = prefs.getBoolPref("editor.nvu.sitemanager.openInNewTab");
		//~ DEBUG ( "prefs found" );
	//~ } catch (e) {};
	
	if (FileURL=="")
		FileURL = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)].url;
	EnableAllUI(false);
	window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
	window.top.editPage(FileURL, window.top, true, newTab);
}
/*
var NsmBundle = null;
function getNsmBundle(s) {
	var d = "bundle_nsmcontext";
	s = "NsmConText-" + s;
	try {
		//~ var b = document.getElementById(d).getString(s);
		var b = NsmBundle.getString(s);
	} catch(ex) {
		//~ alert("Unable to get bundle <" + s + "> from <" + d + "> due to:\n" + ex);
	}
	//~ if (!b)
		//~ alert("Unable to get bundle <" + s + "> from <" + d + ">");
	return b;
}
*/
function getNsmBundle(s) {
	try {
		var b = NsmBundle.getCharPref(s);
	} catch(ex) {
		b = s;
		//~ alert("Unable to get bundle <" + s + "> from <" + d + "> due to:\n" + ex);
	}
	return b;
}
//
// Site Manager Items
function GetItemType(item) {
	/*        var newItem = {
				name: name,
				url: url,
				size: size,
				lastModified: lastModified,
				isContainer: isContainer,
				isContainerOpen: isContainerOpen,
				isContainerEmpty: isContainerEmpty,
				isSymLink: isSymLink,
				level: level,
				hidden: hidden,
				realIndex: realRowIndex
			      };
	*/  
	var type;
	if (item.level == 0) 
		type = "Site";
	else if (item.isContainer) 
		type = "Folder";
	else if (!IsHiddenByFilter("html", item.url))
		type = "HTML Document";
	else if (!IsHiddenByFilter("cgi", item.url))
		type = "Server script";
	else if (!IsHiddenByFilter("css", item.url))
		type = "CSS Stylesheet";
	else if (!IsHiddenByFilter("images", item.url))
		type = "Image";
	else
		type = "File";
	return type;
}
function GetSelectedSite(url) {
	var rowIndex;
	if (url)
		rowIndex = GetItemFromUrl(url).realIndex;
	else
		rowIndex = GetSelectedItem(gDialog.SiteTree);

	// Get related site item
	while (gFilteredItemsArray[rowIndex].level > 0)
		rowIndex--;
	var siteItem = gFilteredItemsArray[rowIndex];
	siteItem.browseUrl = NsmPublishPrefs.getCharPref(siteItem.name + ".browse_url");
	return siteItem;
}
function GetItemFromUrl(url) {
	// Get related item index
	//~ var rowIndex = GetSelectedItem(gDialog.SiteTree);
	var rowIndex = 0;
	if (url) {
		while ((gFilteredItemsArray[rowIndex].url != url) && (rowIndex < gFilteredItemsArray.length-1))
			rowIndex++;
	} else
		rowIndex = GetSelectedItem(gDialog.SiteTree);
	return gFilteredItemsArray[rowIndex];
}
//
// Modified 'openFile' and 'IsHiddenByFilter' functions (override those in 'comm.jar/editor/content/sitemanager.js')
function openFile(e) {
	if (e.button != 0)
		return;
	
	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	var editor = "";
	//~ alert ("root = " + NVU_ROOT_PATH + "\nprofile = " + NVU_PROFILE_PATH);

	// Folder (do nothing)
	if (item.isContainer) {
	}
	// HTML file: open in a new / existing tab
	else if (!IsHiddenByFilter("html", item.url)) {
		var prefs = window.top.GetPrefs();
		var newTab = false; // default is false
		try {
			newTab = prefs.getBoolPref("editor.nvu.sitemanager.openInNewTab");
			DEBUG ( "prefs found" );
		} catch (e) {};
		//~ EnableAllUI(false);
		//~ window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
		//~ window.top.editPage(item.url, window.top, true, newTab);
		NsmEdit(newTab, item.url)
	} 
	// other file: open with external editor
	else {
		// Get file type
		// TODO: loop with all user-defined filters
		if (!IsHiddenByFilter("images", item.url))
			editor = "imgEditor";
		else if (!IsHiddenByFilter("css", item.url))
			editor = "cssEditor";
		else
			editor = "extEditor";
		
		// Get appropriate editor path
		try {
			// ":" is used as PortableNvu's root dir (demo, should use '%NvuRoot%' and '%NvuProfile%' instead)
			var AppPath = NsmPrefs.getCharPref(editor);
			//~ DEBUG ( "prefs found" );
		} catch (e) {
			EnableAllUI(false);
			window.top.document.getElementById("tabeditor").endNavigationCallback = EndNavigation;
			window.top.document.open(item.url, window.top, true, true);
		};
		
		// Launch appropriate editor
		try {
			NsmLaunchExe(AppPath, item.url);
			//~ DEBUG ( "app launched" );
		} catch (e) {};
	}
}
function IsHiddenByFilter(filter, fileName) {
	//~ if (filter == "all")
		//~ return false;
	
	if (filter == "html")
		var re = /\.html?$|\.shtml?$/i ;
	else if (filter == "images")
		re = /\.gif$|\.png$|\.jpg$|\.jpeg$|\.ico$/i ;
	else if (filter == "css")
		re = /\.css$/i ;
	else if (filter == "cgi")
		re = /\.php$|\.asp$|\.jsp$|\.pl$/i ;
	else
		return false;
		
	return !re.test(fileName);
}
//
// Modified 'loadExternalURL' function (override that in 'comm.jar/editor/content/ComposerCommands.js')
var NsmPreviewAppRef = -1;
function loadExternalURL(url) {
	if (url == "")
		url = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)].url;
	if (url) {
		if (NsmPreviewAppRef >= 0) { // launch custom browser
			//~ var AppPath = LaunchyContext.apps[NsmPreviewAppRef].exe;
			NsmLaunch(NsmPreviewAppRef, url);
			NsmPreviewAppRef = -1; // reset to default browser
		} else { // launch default browser
			var ioService = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService);
			var uri = ioService.newURI(url, null, null);
			var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
				.getService(Components.interfaces.nsIExternalProtocolService);
			extProtocolSvc.loadUrl(uri);
		}
	}
}

//
// Modified 'UpdateStructToolbar' function (override that in 'comm.jar/editor/content/editor.js')
function newStructToolbarButton(tag, attr) {
	var ttip, tagId, attrName, attrValue, attref;
	
	button = document.createElementNS(XUL_NS, "toolbarbutton");
	button.setAttribute("value", tag);
	
	// get user prefs
	var ShowId    = false;
	var ShowClass = false;
	var ShowAttrs = false;
	try {
		ShowId    = ToolbarPrefs.getBoolPref("ShowId");
		ShowClass = ToolbarPrefs.getBoolPref("ShowClass");
		ShowAttrs = ToolbarPrefs.getBoolPref("ShowAttrs");
	} catch (e) {};
	
	// Let's add "id" and "class" attributes in the label
	// and other attributes in the tooltip
	ttip = "";
	tagId = "";
	for (attref = 0; attref < attr.length; attref++) {
		attrName  = attr[attref].nodeName;
		attrValue = attr[attref].value;
		if (ShowId && (attrName == "id"))
			tagId = ' id="' + attrValue + '"' + tagId;
		else if (ShowClass && (attrName == "class"))
			tagId += ' class="' + attrValue + '"';
		else if (ShowAttrs)
			ttip += attrName + '="' + attrValue + '" ';
	}
	button.setAttribute("label", "<" + tag + tagId + ">");
	
	if (ttip != "")
		button.setAttribute("tooltiptext", ttip);
	
	return button;
}
function UpdateStructToolbar() {
  var editor = GetCurrentEditor();
  if (!editor) return;

  var mixed = GetSelectionContainer();
  if (!mixed) return;
  var element = mixed.node;
  var oneElementSelected = mixed.oneElementSelected;

  if (!element) return;

  NotifyProcessors(kProcessorsWhenSelectionChanges, element);

  if (element == gLastFocusNode &&
      oneElementSelected == gLastFocusNodeWasSelected)
    return;

  gLastFocusNode = element;
  gLastFocusNodeWasSelected = mixed.oneElementSelected;

  var toolbar = document.getElementById("structToolbar");
  if (!toolbar) return;
  var childNodes = toolbar.childNodes;
  var childNodesLength = childNodes.length;
  // We need to leave the <label> to flex the buttons to the left
  // so, don't remove the last child at position length - 1
  for (var i = childNodesLength - 2; i >= 0; i--) {
    toolbar.removeChild(childNodes.item(i));
  }

  toolbar.removeAttribute("label");

  if ( IsInHTMLSourceMode() ) {
    // we have destroyed the contents of the status bar and are
    // about to recreate it ; but we don't want to do that in
    // Source mode
    return;
  }

  // XXXXXX
  if (true)
  {
    UpdateRulers(element);
    if (!gScrollListener)
      gScrollListener        = GetCurrentEditor().document.addEventListener("scroll", UpdateRulerRequestListener, false);
    if (!gResizeListener)
      gResizeListener        = window.addEventListener("resize", UpdateRulerRequestListener, false);
    if (!gEditorUpdatedListener)
      gEditorUpdatedListener = GetCurrentEditor().document.addEventListener("editorViewUpdated", UpdateRulerRequestListener, false);
  }

  var bodyElement = GetBodyElement();
  var isFocusNode = true;
  var tmp;
  var tag = gLastFocusNode.nodeName.toLowerCase();

  toolbar.firstChild.removeAttribute("style");
  var button;
  do {
    tag = element.nodeName.toLowerCase();

    // <Kaze>
    //~ button = document.createElementNS(XUL_NS, "toolbarbutton");
    //~ button.setAttribute("label",   "<" + tag + ">");
    //~ button.setAttribute("value",   tag);
    // Let's add "id" and "class" attributes in the tag
    // and other attributes in the tooltip
    button = newStructToolbarButton(tag, element.attributes);
    // </Kaze>
    button.setAttribute("context", "structToolbarContext");
    button.className = "struct-button";

    toolbar.insertBefore(button, toolbar.firstChild);

    button.addEventListener("command", newCommandListener(element), false);
    button.addEventListener("contextmenu", newContextmenuListener(button, element), false);

    if (isFocusNode && oneElementSelected) {
      button.setAttribute("checked", "true");
      isFocusNode = false;
    }

    tmp = element;
    element = element.parentNode;

  } while (tmp != bodyElement);
}

// this should be in a [NsmConTextMenu] class definition
function NsmClearMenu(menuid) {
	var children = menuid.childNodes;
	for (var j = children.length-1; j >= 0; j--)
		menuid.removeChild(children[j]);
}
function NsmAppendLaunchyItem(menuid, AppRef, command) {
	var menuitem = document.createElement("menuitem");	
	menuitem.setAttribute("label", LaunchyContext.apps[AppRef].name);
	//~ menuitem.setAttribute("label", "Ouvrir avec " + LaunchyContext.apps[AppRef].name);
	menuitem.setAttribute("oncommand", command);
	if (typeof(LaunchyContext.showfileicons) != "undefined" && LaunchyContext.showfileicons) {
		menuitem.setAttribute("class", "menuitem-iconic");
		menuitem.setAttribute("image", "moz-icon:file://" + LaunchyContext.apps[AppRef].exe + "?size=16");
	}
	menuid.appendChild(menuitem);
}
function NsmAppendLaunchyItems(menuid, type) {
	for (var i = 0; LaunchyContext.apps.length > i; i++)
		if (LaunchyContext.apps[i].type == type)
			NsmAppendLaunchyItem(menuid, i, "NsmLaunch(" + i + ", '')");
}
function NsmAppendMenuItem(menuid, label, command) {
	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", label);
	menuitem.setAttribute("oncommand", command);
	menuid.appendChild(menuitem);
}
function NsmAppendMenuPopup(menuid, label, command) {
	//~ var menuitem = document.createElement("menuitem");
	var menu = document.createElement("menu");
	menu.setAttribute("label", label);
	menu.setAttribute("id", "NsmMenu"+label);
	
	var menupopup = document.createElement("menupopup");
	menupopup.setAttribute("id", "NsmPopup"+label);
	//~ menupopup.setAttribute("onpopupshowing", command);	
	if (label == "Ouvrir") {
		//~ NsmConTextOpen(menupopup);
		NsmAppendMenuItem(menupopup, "Nouvel onglet", "NsmEdit(true,'')");
		NsmAppendMenuItem(menupopup, "Nouvelle fentre", "NsmEdit(false,'')");
		NsmAppendMenuSeparator(menupopup);
		//~ NsmAppendLaunchyItems(menupopup, 7);
	} else if (label == "Navigateur") {
		//~ NsmConTextPreview(menupopup);
		NsmAppendMenuItem(menupopup, "Navigateur par dfaut", "NsmPreviewAppRef=-1; loadExternalURL()");
		NsmAppendMenuSeparator(menupopup);
		//~ NsmAppendLaunchyItems(menupopup, 1);
	}
	menuid.appendChild(menu);
	menu.appendChild(menupopup);
}
function NsmAppendMenuSeparator(menuid) {
	var menuseparator = document.createElement("menuseparator");
	menuid.appendChild(menuseparator);
}
// sitemanagerOverlay.xul (sitemanager context menu)
function NsmConText(menuid) {
	//~ NsmBundle = document.getElementById("bundle_nsmcontext");
	
	NsmClearMenu(menuid, LaunchyContext.apps);
	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	var scheme = GetScheme(item.url);
	
	// Folders
	if (item.isContainer) {
		NsmAppendLaunchyItems(menuid, 6);
		if (scheme == "ftp")
			NsmAppendLaunchyItems(menuid, 4);
		NsmAppendMenuSeparator(menuid);
	}
	// HTML documents
	else if (!IsHiddenByFilter("html", item.url)) {
		NsmAppendMenuItem(menuid, getNsmBundle("NewTab"), "NsmEdit(true,'')");
		NsmAppendMenuItem(menuid, getNsmBundle("NewWindow"), "NsmEdit(false,'')");
		NsmAppendMenuSeparator(menuid);
		try {
			if ((scheme == "file") && NsmPrefs.getBoolPref("ShowEditors")) {
				NsmAppendLaunchyItems(menuid, 7);
				NsmAppendMenuSeparator(menuid);
			}
			if (NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
	}
	// Server-side scripts
	else if (!IsHiddenByFilter("cgi", item.url)) {
		try {
			if (scheme == "file") {
				NsmAppendLaunchyItems(menuid, 7);
				NsmAppendMenuSeparator(menuid);
			}
			if ((GetSelectedSite().browseUrl != "http://") && NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	}
	// other local files
	else if (scheme == "file") {
		if (!IsHiddenByFilter("images", item.url))
			NsmAppendLaunchyItems(menuid, 8);
		else
			NsmAppendLaunchyItems(menuid, 7);
		NsmAppendMenuSeparator(menuid);
	}
	
	if (item.level > 0) {
		// file or folder : rename, remove or show properties
		NsmAppendMenuItem(menuid, getNsmBundle("Rename"), "Rename()");
		NsmAppendMenuItem(menuid, getNsmBundle("Remove"), "RemoveFileOrDir()");
		NsmAppendMenuSeparator(menuid);
		//~ NsmAppendMenuItem(menuid, getNsmBundle("Properties"), "openPropDialog()");
	} else {
		// site : http preview
		try {
			//~ if ((NsmPrefs.getBoolPref("ShowBrowsers")) && (NsmPublishPrefs.getCharPref(item.name + ".browse_url") != "http://")) {
			if (NsmPublishPrefs.getCharPref(item.name+".browse_url") != "http://") {
				NsmAppendLaunchyItems(menuid, 1);
				NsmAppendMenuSeparator(menuid);
			}
		} catch (e) {};
	}
	NsmAppendMenuItem(menuid, "NsmConText...", "openPrefDialog()");
/*	
	//~ var menuitem = document.getElementById("NsmDefaultAction");
	//~ menuitem.setAttribute("class", "menuitem-iconic");
	//~ menuitem.setAttribute("image", iconPath);
	//~ alert(iconPath);
	//~ menuitem.setAttribute("image", "moz-icon:file://" + LaunchyContext.apps[i].exe + "?size=16");
	//~ menuitem.setAttribute("icon", icon);
}*/
}
/* oldies
function NsmConText(menuid) {
	//~ NsmBundle = document.getElementById("bundle_nsmcontext");
	
	var edit = document.getElementById("NsmConText-edit");
	NsmClearMenu(edit);
	var browse = document.getElementById("NsmConText-browse");
	NsmClearMenu(browse);
	//~ NsmClearMenu(menuid, LaunchyContext.apps);
	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	var scheme = GetScheme(item.url);
	if (item.isContainer) {
		NsmAppendLaunchyItems(browse, 6);
		if (scheme == "ftp")
			NsmAppendLaunchyItems(browse, 4);
		NsmAppendMenuSeparator(browse);
	} else if (!IsHiddenByFilter("html", item.url)) {
		//~ nsmMenu.AppendMenuItem("Ouvrir", "openFile(event)");
		NsmAppendMenuItem(edit, "Nouvel onglet", "NsmEdit(true,'')");
		NsmAppendMenuItem(edit, "Nouvelle fentre", "NsmEdit(false,'')");
		NsmAppendMenuSeparator(edit);
		try {
			if ((scheme == "file") && NsmPrefs.getBoolPref("ShowEditors")) {
				NsmAppendLaunchyItems(edit, 7);
				NsmAppendMenuSeparator(edit);
			}
			if (NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	} else if (!IsHiddenByFilter("cgi", item.url)) {
		try {
			if (scheme == "file") {
				NsmAppendLaunchyItems(edit, 7);
				NsmAppendMenuSeparator(edit);
			}
			if ((GetSelectedSite().browseUrl != "http://") && NsmPrefs.getBoolPref("ShowBrowsers")) {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
		//~ nsmMenu.AppendMenuPopup(menuid, "Ouvrir", "NsmConTextOpen(this)");
		//~ nsmMenu.AppendMenuPopup(menuid, "Navigateur", "NsmConTextPreview(this)");
	} else if (scheme == "file") {
		if (!IsHiddenByFilter("images", item.url))
			NsmAppendLaunchyItems(edit, 8);
		else
			NsmAppendLaunchyItems(edit, 7);
		NsmAppendMenuSeparator(edit);
	}
	
	if (item.level > 0) {
		//~ NsmAppendMenuItem(menuid, "Renommer", "Rename()");
		//~ NsmAppendMenuItem(menuid, "Supprimer", "RemoveFileOrDir()");
		//~ NsmAppendMenuItem(menuid, NsmBundle.Rename, "Rename()");
		//~ NsmAppendMenuItem(menuid, NsmBundle.Remove, "RemoveFileOrDir()");
		//~ NsmAppendMenuSeparator(menuid);
		//~ NsmAppendMenuItem(menuid, NsmBundle.Properties, "openPropDialog()");
	} else {
		try {
			//~ if ((NsmPrefs.getBoolPref("ShowBrowsers")) && (NsmPublishPrefs.getCharPref(item.name + ".browse_url") != "http://")) {
			if (NsmPublishPrefs.getCharPref(item.name+".browse_url") != "http://") {
				NsmAppendLaunchyItems(browse, 1);
				NsmAppendMenuSeparator(browse);
			}
		} catch (e) {};
	}
	//~ NsmAppendMenuItem(menuid, "NsmConText...", "openPrefDialog()");
}
function NsmConTextPreview(menuid) {
	//~ NsmClearMenu(menuid);
	NsmAppendMenuItem(menuid, "Navigateur par dfaut", "NsmPreviewAppRef=-1; loadExternalURL()");
	NsmAppendMenuSeparator(menuid);
	NsmAppendLaunchyItems(menuid, 1);
}
function NsmConTextOpen(menuid) {
	//~ NsmClearMenu(menuid);
	NsmAppendMenuItem(menuid, "Nouvel onglet", "NsmEdit(true,'')");
	NsmAppendMenuItem(menuid, "Nouvelle fentre", "NsmEdit(false,'')");
	NsmAppendMenuSeparator(menuid);
	NsmAppendLaunchyItems(menuid, 7);
}
function NsmLaunchyContext(menuid) {
	NsmClearMenu(menuid);

	var item = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)];
	if (item.isContainer) {
		NsmAppendLaunchyItems(menuid, 6);
	} else {
		if (!IsHiddenByFilter("html", item.url)) {
			NsmAppendLaunchyItems(menuid, 1);
		}
		if (!IsHiddenByFilter("images", item.url)) {
			NsmAppendLaunchyItems(menuid, 8);
		} else {
			NsmAppendLaunchyItems(menuid, 7);
		}
	}

	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", "preferences...");
	menuitem.setAttribute("oncommand", "openDialog('chrome://launchy/content/options.xul', '', 'chrome,modal');");
	menuid.appendChild(menuitem);
}
*/
// NsmConText.xul (prefs window)
function addNsmPrefItems(menuid, type, pref) {
	NsmClearMenu(menuid);
	var path;
	var value;
	for (var i = 0; LaunchyContext.apps.length > i; i++)
		if (LaunchyContext.apps[i].type == type) {
			path = LaunchyContext.apps[i].exe.replace(/\\/g, "\\\\");
			value = "document.getElementById('" + pref + "').value = '" + path +"';";
			NsmAppendLaunchyItem(menuid, i, value);
		}
}
// editorPreviewOverlay.xul (navigator preview)
function addNsmPreviews(menuid, type) {
	NsmClearMenu(menuid);
	for (var i = 0; LaunchyContext.apps.length > i; i++)
		if (LaunchyContext.apps[i].type == type)
			NsmAppendLaunchyItem(menuid, i, "NsmPreviewAppRef=(" + i + ")");
}

//
// Using jslib to get Nvu's root and profile dirs (to use with PortableNvu)
const NVU_ROOT_PATH = NvuLocalDir("AChrom").parent.path;
const NVU_PROFILE_PATH = NvuLocalDir("PrefD").path;
function NvuLocalDir(dirId) {
	// taken from jslib
	const JS_FILESYSTEM_LOADED = true;
	const JS_FILESYSTEM_FILE   = "filesystem.js";
	const JS_FS_LOCAL_CID      = "@mozilla.org/file/local;1";
	const JS_FS_DIR_CID        = "@mozilla.org/file/directory_service;1";
	const JS_FS_NETWORK_CID    = '@mozilla.org/network/standard-url;1';
	const JS_FS_URL_COMP       = "nsIURL";
	const JS_FS_I_LOCAL_FILE   = "nsILocalFile";
	const JS_FS_DIR_I_PROPS    = "nsIProperties";
	const JS_FS_INIT_W_PATH    = "initWithPath";
	const JS_FS_CHROME_DIR     = "AChrom";		// /usr/src/mozilla/dist/bin/chrome
	const JS_FS_USR_DEFAULT    = "DefProfRt";	// /root/.mozilla
	const JS_FS_PREF_DIR       = "PrefD";		// /root/.mozilla/Default User/k1m30xaf.slt
	const JS_FS_OK             = true;
	const JS_FS_File_Path      = new Components.Constructor (JS_FS_LOCAL_CID, JS_FS_I_LOCAL_FILE, JS_FS_INIT_W_PATH);
	const JS_FS_Dir            = new Components.Constructor (JS_FS_DIR_CID, JS_FS_DIR_I_PROPS);
	const JS_FS_URL            = new Components.Constructor (JS_FS_NETWORK_CID, JS_FS_URL_COMP);
	// getting the requested dir
	var rvService = Components.classes[JS_FS_DIR_CID].getService(Components.interfaces.nsIProperties)
	var path = rvService.get(dirId, Components.interfaces.nsIFile).path;
	var dir = new JS_FS_File_Path(path);
	return dir;
}
// Using Launchy FileIO class to launch apps 
var NsmFileIO = {

	localfileCID : '@mozilla.org/file/local;1',
	localfileIID : Components.interfaces.nsILocalFile,

	urlCID : '@mozilla.org/network/standard-url;1',
	urlIID : Components.interfaces.nsIURL,
	
	processCID : '@mozilla.org/process/util;1',
	processIID : Components.interfaces.nsIProcess,
	
	urlToPath : function(data) {
		try {
			const hasUnescape = (typeof(unescape)=="function");
			var uri = Components.classes[this.urlCID].createInstance(this.urlIID);
			uri.spec = data;
			var file = Components.classes[this.localfileCID].createInstance(this.localfileIID);
			try {
				file.initWithPath(uri.path);
				data = hasUnescape ? unescape(file.path) : file.path;
			} catch (e) {
				// foobar!
			}
			try {
				file.initWithPath(uri.path.replace(/^\//,"").replace(/\//g,"\\"));
				data = hasUnescape ? unescape(file.path) : file.path;
			} catch (e) {
				// foobar!
			}
		}
		catch(e) {
			// foobar!
		}
		return data;
	},

	run : function(file, data) {
		try {
			var len = 0;
			if (data)
				len = data.length;
			else
				data = null;

			var lfile = Components.classes[this.localfileCID].createInstance(this.localfileIID);
			lfile.initWithPath(file);

			if (lfile.isFile() && lfile.isExecutable()) {
				try {
					var process = Components.classes[this.processCID].createInstance(this.processIID);
					process.init(lfile);
					data = process.run(false, data, len);
				} catch (e) {
					// foobar!
				}
			}
		}
		catch(e) {
			// foobar!
		}
		return data;
	}
}
function NsmLaunchExe(AppPath, FileURL) {
	AppPath = AppPath.replace(/^%NvuRoot%/, NVU_ROOT_PATH);
	AppPath = AppPath.replace(/^%NvuProfile%/, NVU_PROFILE_PATH);
	var success = 1;
	
	// only works on local files !
	//~ if (GetScheme(FileURL) == "file") try {
	try {
		var args = new Array();
		args[0] = NsmFileIO.urlToPath(FileURL);
		NsmFileIO.run(AppPath, args);
		//~ DEBUG ( "app launched" );
	} catch (e) {
		success = 0;
	};
	return success;
}
function NsmLaunch(LaunchyAppRef, FileURL) {
	if (FileURL.length > 0)
		url = FileURL;
	else {
		url = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)].url;
		//Experimental: replace ftp://mysite by http://mysite for browser previews
		if (LaunchyContext.apps[LaunchyAppRef].type == 1) {
			url = urlToHttp(url);
			//~ var siteItem = GetSelectedSite();
			//~ if (siteItem.browseUrl != "http://")
				//~ url = url.replace(siteItem.url, siteItem.browseUrl.replace(/\/$/, ""));
		}
	}	
	
	var success = 1;
	var args = new Array();
	if (LaunchyContext.apps[LaunchyAppRef].args.length > 0)
		args[0] = LaunchyContext.apps[LaunchyAppRef].args;
	//~ args[args.length] = NsmFileIO.urlToPath(FileURL);
	//~ if (GetScheme(url) == "file")
	if (url.substring(0, 4) == "file")
		args[args.length] = NsmFileIO.urlToPath(url);
	else
		args[args.length] = url.replace("%2E", ".");
	
	var AppPath = LaunchyContext.apps[LaunchyAppRef].exe;
	AppPath = AppPath.replace(/^%NvuRoot%/, NVU_ROOT_PATH);
	AppPath = AppPath.replace(/^%NvuProfile%/, NVU_PROFILE_PATH);
	// only works on local files !
	try {
		NsmFileIO.run(AppPath, args);
		DEBUG ( "app launched" );
	} catch (e) {
		success = 0;
	};
	return success;
}
function urlToHttp(url) {
	var siteItem;
	var http;
	
	if (url) {
		siteItem = GetSelectedSite(url);
	} else {
		url = gFilteredItemsArray[GetSelectedItem(gDialog.SiteTree)].url;
		siteItem = GetSelectedSite();
	}
	
	if (siteItem.browseUrl != "http://")
		http = url.replace(siteItem.url, siteItem.browseUrl.replace(/\/$/, ""));
	else
		http = url;
	return http;
}

/*
LaunchyContext.prototype.substWinPaths = function(path) {
	if (LaunchyContext.winhooks) {
		if (/%ProgramFiles%/.test(path)) {
			var ProgramFiles = LaunchyContext.winhooks.getRegistryEntry(3, "Software\\Microsoft\\Windows\\CurrentVersion", "ProgramFilesDir");
			var re=/%ProgramFiles%/;
			path = path.replace(re, ProgramFiles);
		}
		if (/%SystemRoot%/.test(path)) {
			var SystemRoot = LaunchyContext.winhooks.getRegistryEntry(3, "Software\\Microsoft\\Windows NT\\CurrentVersion", "SystemRoot");
			re=/%SystemRoot%/;
			path = path.replace(re, SystemRoot);
		}
		if (/%HOMEDRIVE%/.test(path)) {
			var HOMEDRIVE = LaunchyContext.winhooks.getRegistryEntry(2, "Volatile Environment", "HOMEDRIVE");
			re=/%HOMEDRIVE%/;
			path = path.replace(re, HOMEDRIVE);
		}
		if (/%HOMEPATH%/.test(path)) {
			var HOMEPATH = LaunchyContext.winhooks.getRegistryEntry(2, "Volatile Environment", "HOMEPATH");
			re=/%HOMEPATH%/;
			path = path.replace(re, HOMEDRIVE);
		}
	}
	return path;
}
*/
